jpress v3.3.0:
新增：当后台修改用户密码后，强制下线登录账户的功能
新增：新增差距多 InterceptorBuilder 的支持
优化：验证码输入错误后清空验证码输入框
优化：更新文档错误的 url 地址
修复：JPressJson 出现 ClassCastException 异常的问题
修复：后台产品评论页面匿名评论出现模板错误的问题
修复：用户提现可能无法正常提现的问题
修复：在 dev 模式下，在线动态安装插件时，控制台无法输出插件的 Controller 的请求日志的问题
修复：JPress Json 输出自动替换头像 url 时，无法获取最新内容的问题
修复：当文章或产品使用 elasticsearch 并配置密码时，后台填写的账号密码不生效的问题



jpress v3.2.5:
修复：JPress 代码生成器生成的 Maven 的版本号不正确的问题
修复：JPress 后台的重置按钮不起作用的问题
修复：Menu 的 isMyChild() 方法判断错误的问题
修复：用户中心绑定第三方账号页面出现错误的问题
优化：ApiInterceptor 在某些极端情况下可能出现空指针异常的问题
优化：JPress 后台名称修改为动态获取
优化：后台登录功能当密码错误时自动刷新验证码的功能
优化：优化 JPress 的非法词库
优化：用户登录功能支持 Ajax 请求登录



jpress v3.2.4:
修复：紧急修复由于 Jboot 问题导致插件不可用的问题



jpress v3.2.3:
新增：新增用户绑定账号后，取消绑定的功能
新增：尝试性支持 jdk11 ~ jdk14
修复：快递100查询时因签名未转大写，造成签名错误而无法正常显示快递信息问题。感谢 @lixuanqun
修复：下载的附件目录不规范的问题，感谢 @Retire
优化：优化 OauthConnector，支持可以自由配置回调域名
优化：优化 违法关键字 词库



jpress v3.2.2:
优化：JPress 的安装和升级流程
优化：重构第三方登录的授权流程
优化：优化产品的相关指令和注释
修复：使用 QQ 第三方登录的时候无法正常登录的问题
修复：正确设置微信小程序、第三方登录等的首次用户状态
修复：当产品详情页引用 product.js 但是未启用 Swiper 的时候出错的问题
修复：checkout 页面无法正确删除产品的问题
修复：JPress 低版本升级到最新版本是，倘若最后一步不填写管理员账号密码会出错的问题



jpress v3.2.1:
新增：模板预览功能，前端可以通过 url 访问指定已经安装的模板
优化：升级 ckeditor 到最新版本，以支持 word 的复制粘贴功能
优化：通过 QQ 进行第三方登录时，发生错误提示不明显的问题
修复：分销用户无法正确获取分销金额的问题
修复：ArticleService.findListByCategoryId() 的 count 参数不起作用的问题
修复：通过 paypal 进行支付发生错误的问题
修复：加购物车返回的 Json 内容不正确的问题，感谢 @一座城你说你不懂
修复：通过 Github 第三方登录无法获取正确的用户数据的问题



jpress v3.2.0:
新增：添加一个全新的插件：留言插件，方便网站使用其增强 "留言" 功能，同时方便新手作为一个参考去开发自己的插件，感谢作者 @安杰
新增：可以通过 URL 直接访问模板页面的功能，假设存在模板 abc.html，增可以直接通过 http://domain/abc 去访问。
新增：默认模板 calmlog 新增文章搜索功能
新增：产品详情页新增 URL 分享按钮，当产品启用分销时，分销的 URL 可以获得相应的佣金。
优化：重构 TemplateManager，使其代码更加简洁
优化：优化 #CategoriesDirective 指令，防止在产品页面使用时出现类型转换错误的问题
优化：对 BaseProductInfoQuerier 进行重构，方便在开发插件的时候可以获取更多的信息
优化：删除 ArticleServiceProvider 中多余的不必要的注解
优化：对 AddonControllerManager 进行优化，插件的 Controller 的 viewPath 不用必须为 "/" 的问题
优化：对 微信支付的后台配置添加相应的文字说明，方便使用者更加清晰的去使用
优化：对 订单和支付等内容进行 "固化"，不允许自己去支付别人的订单。
修复：当产品启用 Lucene 搜索引擎后，无法搜索其内容的问题
修复：当产品更新的时候，缓存无法及时清空的问题
修复：当产品和文章同时开启 ElasticSearch 搜索引擎的时候，会出现索引覆盖的问题
修复：对用户进行删除的时候，没有删除用户的 OpenId，导致该用户每次访问都会创建新的用户的问题
文档：添加 JPress 升级的相关文档



jpress v3.1.1:
新增：订单超时的时间设置功能，超时订单自动被关闭
新增：新增产品分类的标签 #productCategoryList，用于读取产品分类内容
优化：优化订单列表的文字样式以及发货按钮的显示逻辑
优化：移除 AdminOrderDetailPgeRender 和 UCenterOrderDetailPageRender 的配置支持
优化：优化 install.sh ，在某些时候无法正常安装的问题
优化：优化 docker-compose.yml ，升级 mysql image 到 5.7
优化：用户推出方法 doLogout() 修改为 logout()
优化：优化插件模块，在某些极端情况下出现无法删除插件内容的问题
优化：升级jboot、fastjson、jcseg等相关依赖到最新版本
修复：购买产品时，默认地址不正确的问题
修复：对未支付订单重新支付时，无法选择新地址的问题
修复：修复代码生成器生成的代码内容编辑的 URL 路径错误的问题，感谢  @安杰
修复：代码生成器生成的代码中，进行批量删除时出现404的问题，感谢 @安杰



jpress v3.1.0:
新增：新增 GlobalInterceptor 注解，插件拦截器必须通过此声明才能设置为全局拦截器
新增：AddonUtil 新增 addSharedFunction() 和 removeSharedFunction() 方法，用于对插件共享模板的新增和移除
新增：AddonUtil 新增 getViewPath() 方法，用于获取插件的文件路径
新增：用户注册新增 "默认所有注册用户未激活" 功能，用于在某些特殊场景下进行手动激活
新增：ProductManager 新增 renderProductOptions() 方法，用于在购物车显示产品扩展信息
新增：DFAUtil 新增 printDFAMatches() 方法，用于打印匹配的非法内容
新增：当产品购买完成时，新增发票的申请功能
新增：OrderManager 新增 registerAdminOrderDetailRender 和 registerUCenterOrderDetailRender 方法，用于自定义订单详情的页面显示
优化：升级 Jboot 到 3.0.1 最新版
优化：对 DFAUtil 的 init 进行优化，让其在 App 启动的时候进行 init，否则初次使用的时候会有 "卡顿" 现象
优化：对 API 和 数据提交 等功能做若干个安全优化
优化：对 ProductInfoQuerier 进行重构，更加方便的对产品信息进行查询
优化：对 WechatAuthorizationController 进行重构，使之更加简洁
优化：对 ArticleServiceProvider 使用 Jboot 3.x 的新 API 进行优化
优化：删除 deleteByIds(Object... ids) 方法，使用 batchDeleteByIds(Object... ids) 进行代替
优化：优化产品详情页的相关样式
优化：对 JPress 的 sql 对索引、字段大小等进行优化
优化：对 JPressOptions 进行优化，新增若干可以设置默认数据的方法
优化：对提现功能生成流水的进行事务控制
修复：注册时，当验证码验证错误的时候提示的内容有误的问题
修复：微信回复当设置的图片无法上传时，继续发送图片导致异常的问题
修复：在二级目录下，模板无法正确显示 shortcut icon 的问题
修复：批量删除产品的时候，无法删除产品图片关联表内容的问题
修复：添加产品到购物车时，购物车的产品数量可能不正确的问题
修复：订单详情页里的分销用户显示不正确的问题
修复：_AttachmentController 在某些极端的情况下可能会出现 NPE 的问题
修复：修改jcseg分词模式，解决启用lucene后 文章添加图片或者链接保存报错的问题，感谢 @tanghaiyuan
修复：当开启用户提现功能，提现手续费设置后不显示的问题
修复：当用户提现时，生成的提现流水不正确的问题
修复：修复提现的余额判断逻辑错误的问题，感谢 @jializh123
修复：在手机版下，无法进行余额充值和加入会员的问题
修复：在手机版下，购物车的结算按钮错位，无法进行正常流程下单的问题



jpress v3.0.6:
修复：在某些情况下订单的商品类型错误的问题
修复：微信个人收款和支付宝个人收款在某些情况下无法显示二维码的问题
修复：当送货信息为空的时候，快递信息异常的问题
修复：购物车进行全选所有商品时，可能会弹出没有选择任何内容的错误提示
优化：重命名 findByProductTablendProductId() 为 findByProductTypeAndProductId()
优化：更新 sql 脚本的字段说明
优化：在浏览器双击复制产品标题，订单号码，多了空格，导致查询不出来
优化：优化用户订单列表进行发货操作的时候，对页面进行刷新



jpress v3.0.5:
修复：模板卸载的时候可能无法删除所有已安装的模板文件的问题
修复：修复当文章的分类修改的时候，缓存无法及时更新的问题
修复：在编译的时候由于Jcseg版本不一致可能存在冲突的问题
修复：JPress 在二级目录下进行安装的时候，无法正确访问 install 进行安装的问题
优化：当用户被冻结或者未激活的时候无法上传文件
优化：修改 lucene 的索引目录，防止文章和产品可能存在索引冲突
优化：升级 jcseg 的版本到 v2.6 最新版本
优化：升级 es client 到最新版本



jpress v3.0.4:
修复：在微信浏览器下无法在线充值和会员支付的问题
修复：在Android手机下，通过微信浏览器进行支付有时无法唤起支付确认对话框的问题
修复：JPress 部署在二级目录下可能导致某些图片和样式无法显示的问题
优化：微信通过 JSAPI 进行支付的时候，当出现错误给出明确的错误提示
优化：删除一些无用的代码或者注释的代码段
优化：在手机浏览器下访问用户中心可能会导致某些DIV错位的问题



jpress v3.0.3:
修复：修复插件在线升级、停止和重启可能在某些情况下出现无法启动的问题
修复：修复使用微信支付在微信浏览器下无法正确支付的问题
修复：当已经生成订单的购物车再次发起时错处的问题
优化：优化自带的模板样式以及评论组件等
优化：优化页面评论的一些js验证问题
优化：优化checkout在手机浏览器下html错位的问题
优化：在支付页面手机浏览器下html错位的问题
优化：在手机浏览器下，用户中心订单和投稿html错位的问题



jpress v3.0.2:
新增：新增基于 DFA 算法的垃圾内容评论、投稿过滤
新增：#hasMember 和 #hasAnyMember 的模板标签
修复：修复 hasMember 和 hasAnyMember 指令无法使用的问题
修复：优惠劵大于 订单金额会导致 负数的问题，感谢 @orangehs



jpress v3.0.1:
新增：OSS 同步删除文件的后台配置，感谢 @haicuan139
新增：收货地址的 API 接口，感谢 @haicuan139
新增：用户中心新增优惠券查看的功能，感谢 @haicuan139
新增：后台的用户详情现在优惠券的查看及分配的功能，感谢 @haicuan139
新增：支付台新增可以在支付的时候可以选择自己的优惠券的功能，感谢 @haicuan139
新增：文章的 API 新增文章搜索的功能，感谢 @haicuan139
新增：产品模块新增产品搜索的功能，感谢 @haicuan139
新增：hasPermission(String actionKey) 的模板方法
优化：当 JPress 渲染的模板文件不存在时，给出更加明确的错误提示。
优化：如果用户第一次添加收货地址，设定为默认地址，感谢 @haicuan139
优化：增加了收货地址的空字段验证，感谢 @haicuan139
优化：后台管理的用户资料菜单增加权限判断，可通过权限配置来控制菜单的显示，感谢 @haicuan139
优化：对 hasPermission 指令错误提示优化
优化：对模板方法的相关类全部修改为 Function 结尾
修复：修复后台的模板设置功能，无法正确渲染模板的图片的问题
修复：修复微信支付不能出现404错误的问题
修复：修复了新增地址时设置默认地址不生效的问题，感谢 @haicuan139
修复：修复后台的用户订单列表无法对其搜索的bug，感谢 @haicuan139



jpress v3.0.0:
新增：新增 hasMember() 和 hasAnyMember() 两个模板指令，更加方便的对会员内容进行控制
优化：强化对可能产生 XSS 漏洞的 Model 防护
优化：优化模板方法 maxLength() 的逻辑
优化：优化后台上传文件时，更加友好的显示上传进度
优化：升级 JPress 的所有版本未 3.0
优化：优化 后台编辑器 切换的文字内容，使之更加直观
优化：升级 JPress 所有 maven 依赖的到最新版本
优化：优化订单列表的不同状态显示不同的颜色，使之更加直观
优化：JPress 在安装或者重新安装时，当出现错误时给出更明确的错误提示
优化：默认情况下，JPress 会开启评论功能，除非手动关闭
修复：修复后台 CKEditor 和 Markdown 编辑器无法切换的问题
修复：修复用户中心文章投稿可能产生恶意投稿的问题
修复：修复 JPress 启动时可能出现的目录无法找到的问题
修复：修复 后台无法对产品评论进行回复和编辑的问题
修复：修复 产品评论回复后该产品的被回复数量数据不正确的问题
修复：修复 产品标签点击后会显示 404 的问题
修复：倘若插件有复合主键的 Model，无法对其进行正确操作的问题



jpress v3.0.0-rc.3:
优化：文章分类归属后，再次修改分类内容会导致文章分类更新不及时的问题
优化：在会员支付、充值等页面调整为 Ajax 提交和验证
优化：优化 jpress 初始化的 sql，对某些索引进行优化 和 文字说明
优化：优化后台模板编辑的文件排序
优化：对 OrderManager 进行重构，方便订单不同逻辑的解耦
优化：用户收入类型新增优惠码推广收入
优化：升级 JFinal、Undertow、Jboot 到最新版本
修复：商品标签修改后缓存不更新的问题
修复：支付页面未配置微信转账支付时可能会报错的问题
修复：修复优惠券后台创建后不能再次分配的问题
修复：修复模板由于打包不规范可能会导致后台模板无法显示的问题
修复：修复后台查看用户流水情况显示的是登录用户流水的问题



jpress v3.0.0-rc.2:
新增：新增获取商品的 API
新增：商品的smartField功能，感谢 @喜欢吃豆包
新增：新增产品标签 @categoryProducts、@nextProduct、@previousProduct、@relevantProducts
优化：优化默认的文章评论、商品评论和页面评论 UI 样式问题
优化：完善当对订单进行支付，再次支付直接跳转到成功页面
优化：优化产品后台对产品编辑是填写的产品视频以及视频封面图的问题
优化：优化当有多个订单项时，订单的商品描述的构建逻辑
优化：优化 JsoupUtil 对 a 标签的过滤逻辑
优化：优化 文章评论、页面评论 和 商品评论 的验证码判断逻辑
优化：优化 当未登录用户 对产品进行操作时的登录逻辑
优化：后台对产品删除时，同时删除其关联的图片列表设置
修复：当用户未登录时，直接购买商品的 js 错误问题
修复：修复 UTM 拦截器里，当微信小程序传入 JWt 时无法正确获取用户的问题
修复：CSRF 拦截器可能会对 do 开头的单词方法进行拦截的问题
修复：修复当使用支付宝进行支付时，当产品标题有空格会造成签名错误的问题
修复：商品访问的真实数量不更新的问题，感谢 @喜欢吃豆包
修复：获取相似商品api接口sql错误，感谢 @喜欢吃豆包
修复：SmartField 对复选框、单选框和下拉菜单设置的文本内容不起作用的问题
修复：修复后台商品的产品列表无法添加的问题
修复：商品的标签和分类 不可删除的问题，感谢 @喜欢吃豆包
修复：订单筛选不可用的问题，感谢 @喜欢吃豆包
修复：calmlog 的商品详情模板的推荐商品代码逻辑问题
修复：产品 和 文章的分类、标签再次更新时由于缓存原因不能及时更新的问题
修复：支付台页面的支付类型不能自动选择的问题
修复：非用户中心的模板页面无法获取购物车信息的问题
修复：后台对附件删除时无法对物理文件删除的问题



jpress v3.0.0-rc.1:
新增：后台新增用户的金额显示能力
新增：新增用户标签的功能
新增：新增会员的购买记录功能
新增：新增用户提现的功能
新增：新增一键发送邮件、短信、模板消息到用户的功能
新增：新增全局标签 #(CDN) 用于读取后台配置 CDN 的功能
优化：新的后台登录背景图
优化：优化 JPressOptions 大小写可能和 Mysql 不一致的问题
优化：优化 后台支付宝支付配置的显示问题
优化：优化支付宝和微信支付扫码成功时，自动跳转的逻辑判断
优化：完善微信支付后台的文字提示内容
优化：优化产品保存成功时的文字提示
优化：优化订单详情的快递信息显示错位的问题
优化：删除用户中心对评论的再次编辑功能
优化：后台在不配置运行上传附件大小的情况下，默认上传最大附件为 10 MB
修复：微信扫码支付签名错误的问题
修复：修复微信充值支余额付入账可能错误的问题
修复：修复会员组编辑出错的问题
修复：修复由于缓存问题导致后台更新产品时，前台没有发生变化的问题
修复：后台重新对产品编辑可能出错的问题
修复：修复后台对文件上传大小填写0时，不是允许上传任意大小的问题
修复：修复 index 为 Action 时，肯能权限无法访问的问题



jpress v3.0.0-beta.2:
新增：支付宝设置新增扫码支付的开关功能
新增：新增支付宝支付的 wap 浏览器唤起支付宝 APP 支付的功能
新增：订单新增是否是虚拟产品和是否支持退款的支持
新增：新增有新订单时，可以通过邮件、手机短信 和 微信公众号通知管理员的功能
新增：新增 GetOpenIdAddon 微信运营插件
新增：新增 后台可以填写管理员邮箱、手机号和微信 openId 的功能
新增：新增后台 邮件配置时，可以进行一键测试的功能
新增：新增可以对页面进行评论额功能
优化：优化文章评论的邮件发送配置功能
优化：微信菜单设置的选择功能和错误提示
优化：优化后台支付宝收款账号的帮助文字内容。
优化：优化文章和产品评论的验证码显示
优化：重构 PayController 的相关代码
优化：重构 JPress 的安装和升级流程
优化：优化用户支付成功时，能顺利进入用户所需模块
优化：重构支付成功时，对 payment 的通知流程
优化：重构 Sitemap 模块，减少文章的查询功能，提供效率
优化：重构 物流选择模块，可以通过插件等其他方式新增物流查询方式
优化：优化用户登录的钉钉第三方支付帮助文字错误的问题
优化：优化模板的指令和layout，让4套自带模板统一
优化：优化后台在删除数据的时候，给出确认对话框
优化：升级 Jboot 到 v2.2.8 最新版本，并对 JPress 线程池的创建进行重构
修复：修复通过用户和类型去获取OpenId可能出错的问题
修复：修复优惠券编辑时可能出错的问题
修复：修复优惠券无法删除的问题
修复：修复支付宝充值时，当有小数点充值不到账的bug
修复：修复支付宝和微信充值时，流水信息不正确的问题
修复：修复财务基础设置里填写的域名无法显示的问题
修复：修复支付宝和微信扫码支付时，无法正常刷新的问题
修复：用户进行分销时，当订单延迟结束时，分销金额无法到账的问题



jpress v3.0.0-beta.1:
新增：JPress v2 平滑升级到 v3 的功能
新增：微信回复的默认回复功能支持回复任何的数据类型
新增：后台订单详情详细显示每个订单项的分销人及分销金额
新增：文章新增可以自定义文章发布时间的功能
新增：#articles 指令新增可以传入多个 flag 的功能
修复：defaultArticleCommentItem 和 defaultProductCommentItem 在关闭评论时任然显示回复按钮的问题
修复：产品和文章评论时，当有父级评论时无法正确显示的问题
修复：当开启阿里云的 OpenSearcher 或 Es，但是填写的配置不正确时，无法保存文章的问题
修复：新增当产生分销时，分享着无法正确获取收入的问题
修复：JsoupUtil.getText() 会对 escape 内容进行转换的问题
修复：优惠券编辑时可能出错的问题
修复：微信在线支付和支付宝在线支付无法正确显示二维码的问题
优化：defaultArticleCommentItem 和 defaultProductCommentItem 的回复样式
优化：优化微信回复的 placeholder 的内容
优化：优化选择图片组件默认图片以及UI间距等问题
优化：jp-image-browser class 修改为 btn-image-browser
优化：删除 payment 以及 userOrder 表的无用字段
优化：修改 isLogineUserModel() 和 notLogineUserModel() 为 isLoginedUserModel() 和 notLoginedUserModel()
优化：升级 Jboot 到 v2.2.7 最新版本



jpress v3.0.0-alpha.2:
新增：新增后台产品的编辑页面，添加会员价的功能
新增：购物车以及结算台新增会员价的展示功能
新增：后台新增管理对会员的修改、删除和续期等功能
优化：购物车选中产品的代码，使之更加容易阅读
优化：继续优化和完善 Mysql 数据库的索引构建
优化：defaultArticleCommentPage 和 defaultProductCommentPage，在关闭评论的时候不再显示评论的输入框
优化：优化插件 Handler 管理器 AddonHandlerManager 和 AddonHandlerProcesser 的逻辑
优化：优化 PaymentManager，减少监听器 isPaySuccess 的判断
优化：微信后台保存菜单时，提示用户必须输入项
优化：微信关键字保存时，添加是否已经存在关键字的友好提示
优化：优化模板管理器 TemplateManger 以及 Template 的相关代码
优化：重构 checkOwner ，修改为 isLogineUserModel 和 notLogineUserModel
修复：商品分类默认页面配置错误，感谢 @喜欢吃豆包
修复：优惠券编辑时 类型和验证类型默认值不显示问题，感谢 @喜欢吃豆包
修复：用户中心的加入会员列表可能出现错误的问题
修复：Windows系统下模板路径肯能出错的问题



jpress v3.0.0-alpha.1:
第一个 3.0 版本

